//
//  Mailbox.m
//  MailDemo
//
//  Created by Scott Stevenson on Wed Apr 21 2004.
//  Copyright (c) 2004 Tree House Ideas. All rights reserved.
//
// David Phillip Oster's additions.
// Thanks to Patrick Machielse for the key insight that makes this work

#import "Mailbox.h"
#import "MyController.h"

@implementation Mailbox

- (id) init {
  if (self = [super init]) {
    emails = [[NSMutableArray alloc] init];
    static int counter = 0;
    NSArray * keys      = [NSArray arrayWithObjects: @"title", nil];
    NSArray * values    = [NSArray arrayWithObjects: [NSString stringWithFormat:@"New Mailbox %d", ++counter], nil];
    [self observeProperties:[NSDictionary dictionaryWithObjects: values forKeys: keys]];
  }
  return self;
}

- (void) dealloc {
  [emails release];
  [super dealloc];
}

- (NSMutableArray *) emails {
    return emails;
}

- (void) setEmails: (NSArray *)newEmails {
  if (emails != newEmails){
    [[[self undoManager] prepareWithInvocationTarget:self] setEmails:emails];
    [emails autorelease];
    emails = [[NSMutableArray alloc] initWithArray: newEmails];
  }
}

- (NSUndoManager *)undoManager {
  return [ (MyController *) [NSApp delegate] undoManager];
}

@end
