#import "MyController.h"

@implementation MyController



#pragma mark -
#pragma mark Startup and Shutdown

- (id) init{
  if (self = [super init]){
    mailboxes_ = [[NSMutableArray alloc] init];
    undo_ = [[NSUndoManager alloc] init];
  }
  return self;
}

- (void) dealloc {
  [[self undoManager] removeAllActionsWithTarget:self];
  [mailboxes_ release];
  [undo_ release];
  [super dealloc];
}



#pragma mark -
#pragma mark Simple Accessors

- (NSMutableArray *) mailboxes{
  return mailboxes_;
}

- (void) setMailboxes: (NSArray *)newMailboxes {
  if (mailboxes_ != newMailboxes){
    [[undo_ prepareWithInvocationTarget:self] setMailboxes:mailboxes_];
    [mailboxes_ autorelease];
    mailboxes_ = [[NSMutableArray alloc] initWithArray: newMailboxes];
  }
}

- (NSUndoManager *)undoManager {
  return undo_;
}

// necessary for undo to work. We must also be window's delegate.
- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender{
	return undo_;
}

@end
