//
//  UndoableArrayController.m
//  MailDemo
//
//  Created by David Phillip Oster on 3/17/07.
//  Copyright 2007 David Phillip Oster. All rights reserved.
//

#import "UndoableArrayController.h"
#import "MyController.h"

@implementation UndoableArrayController
- (NSUndoManager *)undoManager {
  return [ (MyController *) [NSApp delegate] undoManager];
}

- (void)remove:(id)sender {
  NSArray *selected = [self selectedObjects];
  id item;
  if (0 < [selected count] && nil != (item = [selected objectAtIndex:0])) {
    NSUndoManager *undo = [self undoManager];
    if ( ! ([undo isUndoing] || [undo isRedoing])) {
      NSString *undoString = [@"Remove" stringByAppendingString: NSStringFromClass([item class])];
      [undo setActionName:NSLocalizedString(undoString, @"")];
    }
  }
  [super remove:sender];
}
@end
